//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <vector>
#include <algorithm>
#include <functional>
#include <cmath>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


template <class T1, class T2>
struct fopow : public std::binary_function <T1, T2, T1>
{
  T1 operator() (T1 base, T2 exp) const {
    return std::pow(base,exp); 
  }
};


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

int main()
{
  vector<int> coll;

  //      1  9
  for (int i=1; i<=9; ++i) {
      coll.push_back(i);
  }
  PRINT_ELEMENTS(coll," :\n");
  
  //   3,     
  cout << ToRus("  3,     :\n");
  transform (coll.begin(), coll.end(),         // 
             ostream_iterator<int>(cout," "),  // 
             bind1st(fopow<float,int>(),3));   // 
  cout << endl;

  //   ,    3
  cout << ToRus("  ,    3:\n");
  transform (coll.begin(), coll.end(),         // 
             ostream_iterator<int>(cout," "),  // 
             bind2nd(fopow<float,int>(),3));   // 
  cout << endl;

  getch();
  return 0;
}

//---------------------------------------------------------------------------